from manifest_edit import BasePlugin
from manifest_edit import ManifestIterator


class Plugin(BasePlugin):
    '''
    manifest_order plugin.

    The purpose of this plugin is to rearrange track order in manifest files
    based on several possible criteria.

    Limitations: only implemented for .mpd manifests
    '''

    def reorderManifestLists(self, manifest):

        manifest_iterator = ManifestIterator(self.config)

        for order_config, list_to_order in manifest_iterator(manifest,
                                                    ['orderBy', 'orderCriteria']):
            list_to_order.sort(
                key=lambda repr: getattr(
                    repr, order_config['orderBy'], ''),
                reverse=True if order_config['orderCriteria'] == 'desc' else False
            )

    def mpd(self, manifest):
        self.reorderManifestLists(manifest)
